package Counter;

/**
* Illustrates Nested Monitors
*/
public class BoundedCounterVBAD implements BoundedCounter {
	protected long count_ = MIN; 
	protected Condition notMin_ = new SimpleConditionObject();
	protected Condition notMax_ = new SimpleConditionObject();
	public synchronized long value() { return count_; }
	public synchronized void dec() { 
		while (count_ == MIN)
			notMin_.await();									// wait till count not MIN
		if (count_-- == MAX)
			notMax_.signal();
	}
	public synchronized void inc() {			// cant get in!
		while (count_ == MAX)
			notMax_.await();
		if (count_++ == MIN)
			notMin_.signal();									// we never get here!
	}
}