package Counter;

public class Semaphore {
	private long value;

	public Semaphore (long initial)
	{
		value = initial;
	}

	synchronized public void up()
	{
		++value;
		notify();
	}

	synchronized public void down()
		// throws InterruptedException
	{
		while (value== 0)
			try { wait(); }
			catch(InterruptedException ex) { };
		--value;
	}
}