package golf;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

class PlayerArrival extends Panel 
{

	GolfClub golfClub_;
	private String names = "abcdefghijklnopqrstuvxyz";
	private int nextname = 0;

	Button p[];

	PlayerArrival( GolfClub g, int n ) 
	{
		super(new FlowLayout());
		golfClub_ = g;
		p = new Button[n];
		for( int i=0; i<p.length; i++ ) 
		{
			p[i] = new Button( "new Player( "+( i+1 )+" )" );
			p[i].addActionListener( new PlayerArrivalListener( this, i ) ); 
			add( p[i] );
		}
	}

	synchronized void playerArrives( int n ) 
	{
		Thread t = new Player( golfClub_, n+1,
			names.substring( nextname, nextname+1 ) );
		t.start();
		nextname = ( nextname+1 ) % names.length();
	}

	class PlayerArrivalListener implements ActionListener
	{
		final PlayerArrival owner_;
		int number_; 

		public PlayerArrivalListener(  PlayerArrival owner, int number  )
		{
			owner_ = owner;
			number_ = number; 
		}


		public void actionPerformed(  ActionEvent evt  )
		{
			owner_.playerArrives( number_ ); 
		}

	}

}

