

package bridgeSol;

/** This bridge should be safe and fair 
 */
public class FairBridge extends SafeBridge
{

		protected int redWaiting_ = 0;
		protected int blueWaiting_ = 0;
		protected boolean redTurn_ = true;
		protected boolean blueTurn_ = false;

	/** a red car wants to enter the bridge
	 */
	public synchronized void redEnter() throws InterruptedException {
	redWaiting_++;
		while ( blueCars_ > 0 || ( blueWaiting_ > 0 && blueTurn_ ) )
				wait();
		redWaiting_--;
	blueTurn();
		redCars_ ++;
	};
	
	/** a red car exits from the bridge
	 */
	public synchronized void redExit() {
	redCars_ --;
	notifyAll();
	}; 

	/** a blue car wants to enter the bridge
	 */
	public synchronized void blueEnter() throws InterruptedException {
	blueWaiting_++;
		while ( redCars_ > 0 || ( redWaiting_ > 0 && redTurn_ ) )
				wait();
		blueWaiting_--;
	redTurn();
		blueCars_ ++;
	};
	
	/** a blue car exits from the bridge
	 */
	public synchronized void blueExit() {
	blueCars_ --;
	notifyAll();
	}; 

		protected void redTurn() {
		redTurn_ = true; blueTurn_ = false;
		}

		protected void blueTurn() {
		redTurn_ = false; blueTurn_ = true;
		}

}
