/*
  File: Reader.java
*/

package readwriteSol;

import support.*;

public class Reader implements CriticalSection
{

	ReadWrite reader_;

	public Reader( ReadWrite reader )
	{
		reader_ = reader;
	}

	public void enterCriticalSection() throws InterruptedException
	{
		reader_.acquireRead();
	}

	public void leaveCriticalSection()
	{
		reader_.releaseRead();
	}

}
