/*
  File: CountDown.java

*/

package counterdown;

import java.applet.*;
import support.*;

/**
 * CountDown
 *
 **/

public class CountDown extends Applet
{
	int i_;
	
	final static int N = 10;
  
	AudioClip beepSound_; 
	AudioClip tickSound_;

	NumberPanel display_;

	public void init() 
	{
		display_ = new NumberPanel( "Counter" );
		display_.setSize( getSize() );
		add( display_ );
		tickSound_ = getAudioClip( getDocumentBase(), "Sound/tick.au" );
		beepSound_ = getAudioClip( getDocumentBase(), "Sound/beep.au" );
	}

	public void start() 
	{
		i_ = N;
		display_.setValue( i_ );
	}

	public void stop() 
	{
	}

	private void tick()
	{
		display_.setValue( i_ ); 
		tickSound_.play();
		try { 
			Thread.sleep( 1000 );
		} catch (InterruptedException e) {
			return; 
		}
	}

	private void beep()
	{
		display_.setValue( i_ ); 
		beepSound_.play();
	}

}
