/*
  File: Producer.java
*/

package bufferSol;

import support.*;

public class Producer implements TriggerInterface
{
	Buffer buffer_;

	int charval_;

	RotatingPanel rotator_;

	public Producer( Buffer buffer, RotatingPanel rotator )
	{
		buffer_ = buffer;
		charval_ = (int)'a';
		rotator_ = rotator;
		rotator_.setTrigger( this );
	}

	public void start()
	{
		charval_ = (int)'a';
		rotator_.start();
	}

	public void stop()
	{
		rotator_.stop();
	}

	public void performAction() throws InterruptedException
	{
		buffer_.put( new Character( (char)charval_ ) );
		charval_++;
		if ( charval_ > (int)'z' )
			charval_ = (int)'a';
	}

}
