/*
  File: WritersPriorityReadWrite.java
*/

package readwriteSol;

public class WritersPriorityReadWrite extends SafeReadWrite implements ReadWrite 
{

	int waitingWriters_ = 0;

	public WritersPriorityReadWrite( ReaderWriterPanel view )
	{
		super(view);
	}

	public synchronized void acquireRead() throws InterruptedException 
	{
	// ugly duplicated code -- should factor out wait condition
		while ( waitingWriters_ > 0 || writing_ ) 
			wait();
		readers_++;
		view_.setReader( readers_ );
	}

	public synchronized void acquireWrite() throws InterruptedException 
	{
	waitingWriters_++;
	super.acquireWrite();
	}

	public synchronized void releaseWrite() 
	{
	waitingWriters_--;
	super.releaseWrite() ;
	}

}
